/*
** admxrc2.h -  ADM-XRC SDK API header file (ADMXRC2 interface)
**
** (C) Copyright 2001 Alpha Data Parallel Systems Ltd.
*/

#ifndef _ADATA_ADMXRC2_H
#define _ADATA_ADMXRC2_H

#include <windows.h>

#if defined _MSC_VER
    /* MSVC++ */
#   if defined ADMXRC_DLL
        /* Compiling API library into a DLL */
#       define ADMXRC2_DLLFUNC __declspec(dllexport)
#   else
        /* Importing API library from DLL */
#       define ADMXRC2_DLLFUNC __declspec(dllimport)
#   endif
#else
	/* Borland or other C++ */
#   define ADMXRC2_DLLFUNC
#endif

#include <admxrc2\status.h>
#include <admxrc2\struct.h>

/*
** Function prototypes
*/
#ifdef __cplusplus
extern "C"{
#endif

ADMXRC2_DLLFUNC DWORD __cdecl
ADMXRC2_BuildDMAModeWord(			ADMXRC2_BOARD_TYPE		boardtype,
									ADMXRC2_IOWIDTH			buswidth,
									unsigned int			waitstates,
									DWORD					misc);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_CloseCard(					ADMXRC2_HANDLE			card);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ConfigureFromBuffer(		ADMXRC2_HANDLE			card,
									const void*				buffer,
									unsigned long			length);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ConfigureFromBufferDMA(		ADMXRC2_HANDLE			card,
									const void*				buffer,
									unsigned long			length,
									unsigned int			dma_chan,
									HANDLE 					event);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ConfigureFromFile(			ADMXRC2_HANDLE			card,
									const char*				fileName);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ConfigureFromFileDMA(		ADMXRC2_HANDLE			card,
									const char*				fileName,
									unsigned int			dma_chan,
									HANDLE                  event);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_DoDMA(						ADMXRC2_HANDLE			card,
									ADMXRC2_DMADESC			dmadesc,
									unsigned long			offset,
									unsigned long			length,
									DWORD					local,
									ADMXRC2_DMADIR			direction,
									unsigned int			channel,
									DWORD					mode,
									DWORD					flags,
									unsigned long*			timeout,
									HANDLE 					event);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_DoDMAImmediate(				ADMXRC2_HANDLE			card,
									void*					buffer,
									unsigned long			length,
									DWORD					local,
									ADMXRC2_DMADIR			direction,
									unsigned int			channel,
									DWORD					mode,
									DWORD					flags,
									unsigned long*			timeout,
									HANDLE 					event);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_EnumerateCards(				ADMXRC2_ENUM_FUNCTION	enum_func);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetBankInfo(				ADMXRC2_HANDLE			card,
									unsigned int			bank_index,
									ADMXRC2_BANK_INFO*		info);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetCardInfo(				ADMXRC2_HANDLE			card,
									ADMXRC2_CARD_INFO*		info);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetSpaceInfo(				ADMXRC2_HANDLE			card,
									unsigned int			space_index,
									ADMXRC2_SPACE_INFO*		info);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetSpaceConfig(				ADMXRC2_HANDLE			card,
									unsigned int			space_index,
									DWORD*					flags);

ADMXRC2_DLLFUNC const char* __cdecl
ADMXRC2_GetStatusString(			ADMXRC2_STATUS Status);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetVersionInfo(				ADMXRC2_HANDLE			card,
									ADMXRC2_VERSION_INFO*	info);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_InstallErrorHandler(		ADMXRC2_ERROR_HANDLER   handler);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_LoadBitstream(				ADMXRC2_HANDLE			card,
									const char*				filename,
									ADMXRC2_IMAGE*			image,
									unsigned long*			bytes_read);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_MapDirectMaster(			ADMXRC2_HANDLE			card,
									ADMXRC2_DMADESC			dmadesc,
									unsigned long           offset,
									unsigned long           length,
									ADMXRC2_BUFFERMAP*		map);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_OpenCard(					ADMXRC2_CARDID			card_ID,
									ADMXRC2_HANDLE*			card);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_OpenCardByIndex(			unsigned int 			card_index,
									ADMXRC2_HANDLE*			card);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ProgramBytes(				ADMXRC2_HANDLE			card,
									const DWORD*			program,
									unsigned long			length);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_Read(						ADMXRC2_HANDLE			card,
									ADMXRC2_IOWIDTH			width,
									DWORD					flags,
									DWORD					local,
									void*					buffer,
									unsigned long			len);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ReadConfig(					ADMXRC2_HANDLE			card,
									unsigned long			index,
									DWORD*					value);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_RegisterInterruptEvent(		ADMXRC2_HANDLE			card,
									HANDLE					event);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_SetClockRate(				ADMXRC2_HANDLE			card,
									unsigned int			clock_index,
									double					rate,
									double*					actual);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_SetSpaceConfig(				ADMXRC2_HANDLE			card,
									unsigned int			space_index,
									DWORD					flags);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_SetupDMA(					ADMXRC2_HANDLE			card,
									const void*				buffer,
									unsigned long			size,
									DWORD					flags,
									ADMXRC2_DMADESC*		dmadesc);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_StatusToString(				ADMXRC2_STATUS			status,
									char*					string,
									unsigned long			length);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_SyncDirectMaster(			ADMXRC2_HANDLE			card,
									ADMXRC2_DMADESC			dmadesc,
									unsigned long			offset,
									unsigned long			length,
									ADMXRC2_SYNCMODE		syncmode);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_UnloadBitstream(			ADMXRC2_IMAGE			image);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_UnregisterInterruptEvent(	ADMXRC2_HANDLE			card,
									HANDLE					event);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_UnsetupDMA(					ADMXRC2_HANDLE			card,
									ADMXRC2_DMADESC			dmadesc);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_Write(						ADMXRC2_HANDLE			card,
									ADMXRC2_IOWIDTH			width,
									DWORD					flags,
									DWORD					local,
									const void*				data,
									unsigned long			len);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_WriteConfig(				ADMXRC2_HANDLE			card,
									unsigned long			index,
									DWORD					value);

#ifdef __cplusplus
} 
#endif

#endif /* ADMXRC2_H */

