/*
** flash.h - structures and types used in ADM-XRC API calls
**
** (C) Copyright 2003 Alpha Data Parallel Systems Ltd.
*/

#ifndef _ADATA_ADMXRC2_FLASH_H
#define _ADATA_ADMXRC2_FLASH_H

#include <windows.h>

#if defined _MSC_VER
    /* MSVC++ */
#   if defined ADMXRC_DLL
        /* Compiling API library into a DLL */
#       define ADMXRC2_DLLFUNC __declspec(dllexport)
#   else
        /* Importing API library from DLL */
#       define ADMXRC2_DLLFUNC __declspec(dllimport)
#   endif
#else
	/* Borland or other C++ */
#   define ADMXRC2_DLLFUNC
#endif

#include <admxrc2\status.h>
#include <admxrc2\struct.h>
#include <admxrc2\flashinf.h>

/*
** Function prototypes
*/
#ifdef __cplusplus
extern "C"{
#endif

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_EraseFlash(					ADMXRC2_HANDLE				card,
									unsigned long				start,
									unsigned long				length);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetFlashInfo(				ADMXRC2_HANDLE				card,
									ADMXRC2_FLASH_INFO*			info);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_GetFlashBlockInfo(			ADMXRC2_HANDLE				card,
									unsigned long				location,
									ADMXRC2_FLASHBLOCK_INFO*	info);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_ReadFlash(					ADMXRC2_HANDLE				card,
									unsigned long				start,
									unsigned long				length,
									void*						buffer);

ADMXRC2_DLLFUNC ADMXRC2_STATUS __cdecl
ADMXRC2_WriteFlash(					ADMXRC2_HANDLE				card,
									unsigned long				start,
									unsigned long				length,
									const void*					data);

#ifdef __cplusplus
} 
#endif

#endif
