/*
** flashinf.h - structures and types used in ADM-XRC API calls
**
** (C) Copyright 2003 Alpha Data Parallel Systems Ltd.
*/

#ifndef _ADATA_ADMXRC2_FLASHINF_H
#define _ADATA_ADMXRC2_FLASHINF_H

/*
** Flash information structure
*/
typedef struct _ADMXRC2_FLASH_INFO {
	char	DeviceName[32];		/* Freeform string of device name			*/
	DWORD	DeviceSize;			/* Size of device							*/
	DWORD	DeviceBlockSize;	/* Device normal block size					*/
	DWORD	UseableStart;		/* Region of device for target bitstreams	*/
	DWORD	UseableLength;		/* Region of device for target bitstreams	*/
} ADMXRC2_FLASH_INFO;

/*
** Flash block information structure
*/
#define ADMXRC2_FLASHBLOCKFLAG_BOOT (0x1U) /* Block is a boot block */
typedef struct _ADMXRC2_FLASHBLOCK_INFO {
	DWORD	Flags;				/* See flags definitions above				*/
	DWORD	Start;				/* Size of block							*/
	DWORD	Length;				/* Length of block							*/
} ADMXRC2_FLASHBLOCK_INFO;

#endif
